// This file is generated by kconfig_compiler_kf5 from spectacle.kcfg.
// All changes you do to this file will be lost.
#ifndef SETTINGS_H
#define SETTINGS_H

#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

#include <QStandardPaths>
#include <CaptureModeModel.h>
#include <Gui/Annotations/AnnotationDocument.h>

class Settings : public KConfigSkeleton
{
  Q_OBJECT
  public:
    enum EnumLaunchAction { TakeFullscreenScreenshot, UseLastUsedCapturemode, DoNotTakeScreenshot };
    Q_ENUM(EnumLaunchAction)
    enum EnumPrintKeyActionRunning { TakeNewScreenshot, StartNewInstance, FocusWindow };
    Q_ENUM(EnumPrintKeyActionRunning)
    enum EnumClipboardGroup { PostScreenshotDoNothing, PostScreenshotCopyImage, PostScreenshotCopyLocation };
    Q_ENUM(EnumClipboardGroup)
    enum EnumRememberLastRectangularRegion { Never, Always, UntilSpectacleIsClosed };
    Q_ENUM(EnumRememberLastRectangularRegion)

    static Settings *self();
    ~Settings() override;

    /**
      Set What to do when Spectacle is launched
    */
    static
    void setLaunchAction( int v )
    {
      if (v != self()->mLaunchAction && !self()->isLaunchActionImmutable()) {
        self()->mLaunchAction = v;
        Q_EMIT self()->launchActionChanged();
      }
    }

    Q_PROPERTY(int launchAction READ launchAction WRITE setLaunchAction NOTIFY launchActionChanged)
    Q_PROPERTY(bool isLaunchActionImmutable READ isLaunchActionImmutable CONSTANT)
    /**
      Get What to do when Spectacle is launched
    */
    static
    int launchAction()
    {
      return self()->mLaunchAction;
    }

    /**
      Is What to do when Spectacle is launched Immutable
    */
    static
    bool isLaunchActionImmutable()
    {
      return self()->isImmutable( QStringLiteral( "launchAction" ) );
    }

    /**
      Set What should happen if print key is pressed when Spectacle is already running
    */
    static
    void setPrintKeyActionRunning( int v )
    {
      if (v != self()->mPrintKeyActionRunning && !self()->isPrintKeyActionRunningImmutable()) {
        self()->mPrintKeyActionRunning = v;
        Q_EMIT self()->printKeyActionRunningChanged();
      }
    }

    Q_PROPERTY(int printKeyActionRunning READ printKeyActionRunning WRITE setPrintKeyActionRunning NOTIFY printKeyActionRunningChanged)
    Q_PROPERTY(bool isPrintKeyActionRunningImmutable READ isPrintKeyActionRunningImmutable CONSTANT)
    /**
      Get What should happen if print key is pressed when Spectacle is already running
    */
    static
    int printKeyActionRunning()
    {
      return self()->mPrintKeyActionRunning;
    }

    /**
      Is What should happen if print key is pressed when Spectacle is already running Immutable
    */
    static
    bool isPrintKeyActionRunningImmutable()
    {
      return self()->isImmutable( QStringLiteral( "printKeyActionRunning" ) );
    }

    /**
      Set Save screenshot automatically after it is taken
    */
    static
    void setAutoSaveImage( bool v )
    {
      if (v != self()->mAutoSaveImage && !self()->isAutoSaveImageImmutable()) {
        self()->mAutoSaveImage = v;
        Q_EMIT self()->autoSaveImageChanged();
      }
    }

    Q_PROPERTY(bool autoSaveImage READ autoSaveImage WRITE setAutoSaveImage NOTIFY autoSaveImageChanged)
    Q_PROPERTY(bool isAutoSaveImageImmutable READ isAutoSaveImageImmutable CONSTANT)
    /**
      Get Save screenshot automatically after it is taken
    */
    static
    bool autoSaveImage()
    {
      return self()->mAutoSaveImage;
    }

    /**
      Is Save screenshot automatically after it is taken Immutable
    */
    static
    bool isAutoSaveImageImmutable()
    {
      return self()->isImmutable( QStringLiteral( "autoSaveImage" ) );
    }

    /**
      Set Clipboard action which should be executed after the screenshot is taken
    */
    static
    void setClipboardGroup( int v )
    {
      if (v != self()->mClipboardGroup && !self()->isClipboardGroupImmutable()) {
        self()->mClipboardGroup = v;
        Q_EMIT self()->clipboardGroupChanged();
      }
    }

    Q_PROPERTY(int clipboardGroup READ clipboardGroup WRITE setClipboardGroup NOTIFY clipboardGroupChanged)
    Q_PROPERTY(bool isClipboardGroupImmutable READ isClipboardGroupImmutable CONSTANT)
    /**
      Get Clipboard action which should be executed after the screenshot is taken
    */
    static
    int clipboardGroup()
    {
      return self()->mClipboardGroup;
    }

    /**
      Is Clipboard action which should be executed after the screenshot is taken Immutable
    */
    static
    bool isClipboardGroupImmutable()
    {
      return self()->isImmutable( QStringLiteral( "clipboardGroup" ) );
    }

    /**
      Set Whether to use a light color mask in the region selection dialog
    */
    static
    void setUseLightMaskColor( bool v )
    {
      if (v != self()->mUseLightMaskColor && !self()->isUseLightMaskColorImmutable()) {
        self()->mUseLightMaskColor = v;
        Q_EMIT self()->useLightMaskColorChanged();
      }
    }

    Q_PROPERTY(bool useLightMaskColor READ useLightMaskColor WRITE setUseLightMaskColor NOTIFY useLightMaskColorChanged)
    Q_PROPERTY(bool isUseLightMaskColorImmutable READ isUseLightMaskColorImmutable CONSTANT)
    /**
      Get Whether to use a light color mask in the region selection dialog
    */
    static
    bool useLightMaskColor()
    {
      return self()->mUseLightMaskColor;
    }

    /**
      Is Whether to use a light color mask in the region selection dialog Immutable
    */
    static
    bool isUseLightMaskColorImmutable()
    {
      return self()->isImmutable( QStringLiteral( "useLightMaskColor" ) );
    }

    /**
      Set Whether to show a magnifier in the region selection
    */
    static
    void setShowMagnifier( bool v )
    {
      if (v != self()->mShowMagnifier && !self()->isShowMagnifierImmutable()) {
        self()->mShowMagnifier = v;
        Q_EMIT self()->showMagnifierChanged();
      }
    }

    Q_PROPERTY(bool showMagnifier READ showMagnifier WRITE setShowMagnifier NOTIFY showMagnifierChanged)
    Q_PROPERTY(bool isShowMagnifierImmutable READ isShowMagnifierImmutable CONSTANT)
    /**
      Get Whether to show a magnifier in the region selection
    */
    static
    bool showMagnifier()
    {
      return self()->mShowMagnifier;
    }

    /**
      Is Whether to show a magnifier in the region selection Immutable
    */
    static
    bool isShowMagnifierImmutable()
    {
      return self()->isImmutable( QStringLiteral( "showMagnifier" ) );
    }

    /**
      Set Whether the screenshot should be captured after selecting the region and releasing the mouse
    */
    static
    void setUseReleaseToCapture( bool v )
    {
      if (v != self()->mUseReleaseToCapture && !self()->isUseReleaseToCaptureImmutable()) {
        self()->mUseReleaseToCapture = v;
        Q_EMIT self()->useReleaseToCaptureChanged();
      }
    }

    Q_PROPERTY(bool useReleaseToCapture READ useReleaseToCapture WRITE setUseReleaseToCapture NOTIFY useReleaseToCaptureChanged)
    Q_PROPERTY(bool isUseReleaseToCaptureImmutable READ isUseReleaseToCaptureImmutable CONSTANT)
    /**
      Get Whether the screenshot should be captured after selecting the region and releasing the mouse
    */
    static
    bool useReleaseToCapture()
    {
      return self()->mUseReleaseToCapture;
    }

    /**
      Is Whether the screenshot should be captured after selecting the region and releasing the mouse Immutable
    */
    static
    bool isUseReleaseToCaptureImmutable()
    {
      return self()->isImmutable( QStringLiteral( "useReleaseToCapture" ) );
    }

    /**
      Set Whether to show capture instructions in the region selection
    */
    static
    void setShowCaptureInstructions( bool v )
    {
      if (v != self()->mShowCaptureInstructions && !self()->isShowCaptureInstructionsImmutable()) {
        self()->mShowCaptureInstructions = v;
        Q_EMIT self()->showCaptureInstructionsChanged();
      }
    }

    Q_PROPERTY(bool showCaptureInstructions READ showCaptureInstructions WRITE setShowCaptureInstructions NOTIFY showCaptureInstructionsChanged)
    Q_PROPERTY(bool isShowCaptureInstructionsImmutable READ isShowCaptureInstructionsImmutable CONSTANT)
    /**
      Get Whether to show capture instructions in the region selection
    */
    static
    bool showCaptureInstructions()
    {
      return self()->mShowCaptureInstructions;
    }

    /**
      Is Whether to show capture instructions in the region selection Immutable
    */
    static
    bool isShowCaptureInstructionsImmutable()
    {
      return self()->isImmutable( QStringLiteral( "showCaptureInstructions" ) );
    }

    /**
      Set Remember the last rectangular region
    */
    static
    void setRememberLastRectangularRegion( int v )
    {
      if (v != self()->mRememberLastRectangularRegion && !self()->isRememberLastRectangularRegionImmutable()) {
        self()->mRememberLastRectangularRegion = v;
        Q_EMIT self()->rememberLastRectangularRegionChanged();
      }
    }

    Q_PROPERTY(int rememberLastRectangularRegion READ rememberLastRectangularRegion WRITE setRememberLastRectangularRegion NOTIFY rememberLastRectangularRegionChanged)
    Q_PROPERTY(bool isRememberLastRectangularRegionImmutable READ isRememberLastRectangularRegionImmutable CONSTANT)
    /**
      Get Remember the last rectangular region
    */
    static
    int rememberLastRectangularRegion()
    {
      return self()->mRememberLastRectangularRegion;
    }

    /**
      Is Remember the last rectangular region Immutable
    */
    static
    bool isRememberLastRectangularRegionImmutable()
    {
      return self()->isImmutable( QStringLiteral( "rememberLastRectangularRegion" ) );
    }

    /**
      Set The last used region the user selected
    */
    static
    void setCropRegion( const QRect & v )
    {
      if (v != self()->mCropRegion && !self()->isCropRegionImmutable()) {
        self()->mCropRegion = v;
        Q_EMIT self()->cropRegionChanged();
      }
    }

    Q_PROPERTY(QRect cropRegion READ cropRegion WRITE setCropRegion NOTIFY cropRegionChanged)
    Q_PROPERTY(bool isCropRegionImmutable READ isCropRegionImmutable CONSTANT)
    /**
      Get The last used region the user selected
    */
    static
    QRect cropRegion()
    {
      return self()->mCropRegion;
    }

    /**
      Is The last used region the user selected Immutable
    */
    static
    bool isCropRegionImmutable()
    {
      return self()->isImmutable( QStringLiteral( "cropRegion" ) );
    }

    /**
      Set Take screenshot on click
    */
    static
    void setCaptureOnClick( bool v )
    {
      if (v != self()->mCaptureOnClick && !self()->isCaptureOnClickImmutable()) {
        self()->mCaptureOnClick = v;
        Q_EMIT self()->captureOnClickChanged();
      }
    }

    Q_PROPERTY(bool captureOnClick READ captureOnClick WRITE setCaptureOnClick NOTIFY captureOnClickChanged)
    Q_PROPERTY(bool isCaptureOnClickImmutable READ isCaptureOnClickImmutable CONSTANT)
    /**
      Get Take screenshot on click
    */
    static
    bool captureOnClick()
    {
      return self()->mCaptureOnClick;
    }

    /**
      Is Take screenshot on click Immutable
    */
    static
    bool isCaptureOnClickImmutable()
    {
      return self()->isImmutable( QStringLiteral( "captureOnClick" ) );
    }

    /**
      Set Whether the mouse cursor is included in the screenshot
    */
    static
    void setIncludePointer( bool v )
    {
      if (v != self()->mIncludePointer && !self()->isIncludePointerImmutable()) {
        self()->mIncludePointer = v;
        Q_EMIT self()->includePointerChanged();
      }
    }

    Q_PROPERTY(bool includePointer READ includePointer WRITE setIncludePointer NOTIFY includePointerChanged)
    Q_PROPERTY(bool isIncludePointerImmutable READ isIncludePointerImmutable CONSTANT)
    /**
      Get Whether the mouse cursor is included in the screenshot
    */
    static
    bool includePointer()
    {
      return self()->mIncludePointer;
    }

    /**
      Is Whether the mouse cursor is included in the screenshot Immutable
    */
    static
    bool isIncludePointerImmutable()
    {
      return self()->isImmutable( QStringLiteral( "includePointer" ) );
    }

    /**
      Set Whether the window decorations are included in the screenshot
    */
    static
    void setIncludeDecorations( bool v )
    {
      if (v != self()->mIncludeDecorations && !self()->isIncludeDecorationsImmutable()) {
        self()->mIncludeDecorations = v;
        Q_EMIT self()->includeDecorationsChanged();
      }
    }

    Q_PROPERTY(bool includeDecorations READ includeDecorations WRITE setIncludeDecorations NOTIFY includeDecorationsChanged)
    Q_PROPERTY(bool isIncludeDecorationsImmutable READ isIncludeDecorationsImmutable CONSTANT)
    /**
      Get Whether the window decorations are included in the screenshot
    */
    static
    bool includeDecorations()
    {
      return self()->mIncludeDecorations;
    }

    /**
      Is Whether the window decorations are included in the screenshot Immutable
    */
    static
    bool isIncludeDecorationsImmutable()
    {
      return self()->isImmutable( QStringLiteral( "includeDecorations" ) );
    }

    /**
      Set Only capture the current pop up menu
    */
    static
    void setTransientOnly( bool v )
    {
      if (v != self()->mTransientOnly && !self()->isTransientOnlyImmutable()) {
        self()->mTransientOnly = v;
        Q_EMIT self()->transientOnlyChanged();
      }
    }

    Q_PROPERTY(bool transientOnly READ transientOnly WRITE setTransientOnly NOTIFY transientOnlyChanged)
    Q_PROPERTY(bool isTransientOnlyImmutable READ isTransientOnlyImmutable CONSTANT)
    /**
      Get Only capture the current pop up menu
    */
    static
    bool transientOnly()
    {
      return self()->mTransientOnly;
    }

    /**
      Is Only capture the current pop up menu Immutable
    */
    static
    bool isTransientOnlyImmutable()
    {
      return self()->isImmutable( QStringLiteral( "transientOnly" ) );
    }

    /**
      Set Quit after saving or copying an image
    */
    static
    void setQuitAfterSaveCopyExport( bool v )
    {
      if (v != self()->mQuitAfterSaveCopyExport && !self()->isQuitAfterSaveCopyExportImmutable()) {
        self()->mQuitAfterSaveCopyExport = v;
        Q_EMIT self()->quitAfterSaveCopyExportChanged();
      }
    }

    Q_PROPERTY(bool quitAfterSaveCopyExport READ quitAfterSaveCopyExport WRITE setQuitAfterSaveCopyExport NOTIFY quitAfterSaveCopyExportChanged)
    Q_PROPERTY(bool isQuitAfterSaveCopyExportImmutable READ isQuitAfterSaveCopyExportImmutable CONSTANT)
    /**
      Get Quit after saving or copying an image
    */
    static
    bool quitAfterSaveCopyExport()
    {
      return self()->mQuitAfterSaveCopyExport;
    }

    /**
      Is Quit after saving or copying an image Immutable
    */
    static
    bool isQuitAfterSaveCopyExportImmutable()
    {
      return self()->isImmutable( QStringLiteral( "quitAfterSaveCopyExport" ) );
    }

    /**
      Set Delay
    */
    static
    void setCaptureDelay( double v )
    {
      if (v < 0)
      {
        qDebug() << "setCaptureDelay: value " << v << " is less than the minimum value of 0";
        v = 0;
      }
      if (v != self()->mCaptureDelay && !self()->isCaptureDelayImmutable()) {
        self()->mCaptureDelay = v;
        Q_EMIT self()->captureDelayChanged();
      }
    }

    Q_PROPERTY(double captureDelay READ captureDelay WRITE setCaptureDelay NOTIFY captureDelayChanged)
    Q_PROPERTY(bool isCaptureDelayImmutable READ isCaptureDelayImmutable CONSTANT)
    /**
      Get Delay
    */
    static
    double captureDelay()
    {
      return self()->mCaptureDelay;
    }

    /**
      Is Delay Immutable
    */
    static
    bool isCaptureDelayImmutable()
    {
      return self()->isImmutable( QStringLiteral( "captureDelay" ) );
    }

    /**
      Set captureMode
    */
    static
    void setCaptureMode( int v )
    {
      if (v != self()->mCaptureMode && !self()->isCaptureModeImmutable()) {
        self()->mCaptureMode = v;
        Q_EMIT self()->captureModeChanged();
      }
    }

    Q_PROPERTY(int captureMode READ captureMode WRITE setCaptureMode NOTIFY captureModeChanged)
    Q_PROPERTY(bool isCaptureModeImmutable READ isCaptureModeImmutable CONSTANT)
    /**
      Get captureMode
    */
    static
    int captureMode()
    {
      return self()->mCaptureMode;
    }

    /**
      Is captureMode Immutable
    */
    static
    bool isCaptureModeImmutable()
    {
      return self()->isImmutable( QStringLiteral( "captureMode" ) );
    }

    /**
      Set Default filename
    */
    static
    void setDefaultSaveLocation( const QUrl & v )
    {
      if (v != self()->mDefaultSaveLocation && !self()->isDefaultSaveLocationImmutable()) {
        self()->mDefaultSaveLocation = v;
        Q_EMIT self()->defaultSaveLocationChanged();
      }
    }

    Q_PROPERTY(QUrl defaultSaveLocation READ defaultSaveLocation WRITE setDefaultSaveLocation NOTIFY defaultSaveLocationChanged)
    Q_PROPERTY(bool isDefaultSaveLocationImmutable READ isDefaultSaveLocationImmutable CONSTANT)
    /**
      Get Default filename
    */
    static
    QUrl defaultSaveLocation()
    {
      return self()->mDefaultSaveLocation;
    }

    /**
      Is Default filename Immutable
    */
    static
    bool isDefaultSaveLocationImmutable()
    {
      return self()->isImmutable( QStringLiteral( "defaultSaveLocation" ) );
    }

    /**
      Set Default filename
    */
    static
    void setDefaultVideoSaveLocation( const QUrl & v )
    {
      if (v != self()->mDefaultVideoSaveLocation && !self()->isDefaultVideoSaveLocationImmutable()) {
        self()->mDefaultVideoSaveLocation = v;
        Q_EMIT self()->defaultVideoSaveLocationChanged();
      }
    }

    Q_PROPERTY(QUrl defaultVideoSaveLocation READ defaultVideoSaveLocation WRITE setDefaultVideoSaveLocation NOTIFY defaultVideoSaveLocationChanged)
    Q_PROPERTY(bool isDefaultVideoSaveLocationImmutable READ isDefaultVideoSaveLocationImmutable CONSTANT)
    /**
      Get Default filename
    */
    static
    QUrl defaultVideoSaveLocation()
    {
      return self()->mDefaultVideoSaveLocation;
    }

    /**
      Is Default filename Immutable
    */
    static
    bool isDefaultVideoSaveLocationImmutable()
    {
      return self()->isImmutable( QStringLiteral( "defaultVideoSaveLocation" ) );
    }

    /**
      Set Compression quality for lossy file formats
    */
    static
    void setCompressionQuality( uint v )
    {

      if (v > 100)
      {
        qDebug() << "setCompressionQuality: value " << v << " is greater than the maximum value of 100";
        v = 100;
      }

      if (v != self()->mCompressionQuality && !self()->isCompressionQualityImmutable()) {
        self()->mCompressionQuality = v;
        Q_EMIT self()->compressionQualityChanged();
      }
    }

    Q_PROPERTY(uint compressionQuality READ compressionQuality WRITE setCompressionQuality NOTIFY compressionQualityChanged)
    Q_PROPERTY(bool isCompressionQualityImmutable READ isCompressionQualityImmutable CONSTANT)
    /**
      Get Compression quality for lossy file formats
    */
    static
    uint compressionQuality()
    {
      return self()->mCompressionQuality;
    }

    /**
      Is Compression quality for lossy file formats Immutable
    */
    static
    bool isCompressionQualityImmutable()
    {
      return self()->isImmutable( QStringLiteral( "compressionQuality" ) );
    }

    /**
      Set Default save image format
    */
    static
    void setDefaultSaveImageFormat( const QString & v )
    {
      if (v != self()->mDefaultSaveImageFormat && !self()->isDefaultSaveImageFormatImmutable()) {
        self()->mDefaultSaveImageFormat = v;
        Q_EMIT self()->defaultSaveImageFormatChanged();
      }
    }

    Q_PROPERTY(QString defaultSaveImageFormat READ defaultSaveImageFormat WRITE setDefaultSaveImageFormat NOTIFY defaultSaveImageFormatChanged)
    Q_PROPERTY(bool isDefaultSaveImageFormatImmutable READ isDefaultSaveImageFormatImmutable CONSTANT)
    /**
      Get Default save image format
    */
    static
    QString defaultSaveImageFormat()
    {
      return self()->mDefaultSaveImageFormat;
    }

    /**
      Is Default save image format Immutable
    */
    static
    bool isDefaultSaveImageFormatImmutable()
    {
      return self()->isImmutable( QStringLiteral( "defaultSaveImageFormat" ) );
    }

    /**
      Set Default save image format
    */
    static
    void setDefaultSaveVideoFormat( const QString & v )
    {
      if (v != self()->mDefaultSaveVideoFormat && !self()->isDefaultSaveVideoFormatImmutable()) {
        self()->mDefaultSaveVideoFormat = v;
        Q_EMIT self()->defaultSaveVideoFormatChanged();
      }
    }

    Q_PROPERTY(QString defaultSaveVideoFormat READ defaultSaveVideoFormat WRITE setDefaultSaveVideoFormat NOTIFY defaultSaveVideoFormatChanged)
    Q_PROPERTY(bool isDefaultSaveVideoFormatImmutable READ isDefaultSaveVideoFormatImmutable CONSTANT)
    /**
      Get Default save image format
    */
    static
    QString defaultSaveVideoFormat()
    {
      return self()->mDefaultSaveVideoFormat;
    }

    /**
      Is Default save image format Immutable
    */
    static
    bool isDefaultSaveVideoFormatImmutable()
    {
      return self()->isImmutable( QStringLiteral( "defaultSaveVideoFormat" ) );
    }

    /**
      Set The default filename used when saving
    */
    static
    void setSaveFilenameFormat( const QString & v )
    {
      if (v != self()->mSaveFilenameFormat && !self()->isSaveFilenameFormatImmutable()) {
        self()->mSaveFilenameFormat = v;
        Q_EMIT self()->saveFilenameFormatChanged();
      }
    }

    Q_PROPERTY(QString saveFilenameFormat READ saveFilenameFormat WRITE setSaveFilenameFormat NOTIFY saveFilenameFormatChanged)
    Q_PROPERTY(bool isSaveFilenameFormatImmutable READ isSaveFilenameFormatImmutable CONSTANT)
    /**
      Get The default filename used when saving
    */
    static
    QString saveFilenameFormat()
    {
      return self()->mSaveFilenameFormat;
    }

    /**
      Is The default filename used when saving Immutable
    */
    static
    bool isSaveFilenameFormatImmutable()
    {
      return self()->isImmutable( QStringLiteral( "saveFilenameFormat" ) );
    }

    /**
      Set The default filename used when recording a video
    */
    static
    void setSaveVideoFormat( const QString & v )
    {
      if (v != self()->mSaveVideoFormat && !self()->isSaveVideoFormatImmutable()) {
        self()->mSaveVideoFormat = v;
        Q_EMIT self()->saveVideoFormatChanged();
      }
    }

    Q_PROPERTY(QString saveVideoFormat READ saveVideoFormat WRITE setSaveVideoFormat NOTIFY saveVideoFormatChanged)
    Q_PROPERTY(bool isSaveVideoFormatImmutable READ isSaveVideoFormatImmutable CONSTANT)
    /**
      Get The default filename used when recording a video
    */
    static
    QString saveVideoFormat()
    {
      return self()->mSaveVideoFormat;
    }

    /**
      Is The default filename used when recording a video Immutable
    */
    static
    bool isSaveVideoFormatImmutable()
    {
      return self()->isImmutable( QStringLiteral( "saveVideoFormat" ) );
    }

    /**
      Set The path of the file saved last
    */
    static
    void setLastSaveLocation( const QUrl & v )
    {
      if (v != self()->mLastSaveLocation && !self()->isLastSaveLocationImmutable()) {
        self()->mLastSaveLocation = v;
        Q_EMIT self()->lastSaveLocationChanged();
      }
    }

    Q_PROPERTY(QUrl lastSaveLocation READ lastSaveLocation WRITE setLastSaveLocation NOTIFY lastSaveLocationChanged)
    Q_PROPERTY(bool isLastSaveLocationImmutable READ isLastSaveLocationImmutable CONSTANT)
    /**
      Get The path of the file saved last
    */
    static
    QUrl lastSaveLocation()
    {
      return self()->mLastSaveLocation;
    }

    /**
      Is The path of the file saved last Immutable
    */
    static
    bool isLastSaveLocationImmutable()
    {
      return self()->isImmutable( QStringLiteral( "lastSaveLocation" ) );
    }

    /**
      Set Last path used for "save as" action
    */
    static
    void setLastSaveAsLocation( const QUrl & v )
    {
      if (v != self()->mLastSaveAsLocation && !self()->isLastSaveAsLocationImmutable()) {
        self()->mLastSaveAsLocation = v;
        Q_EMIT self()->lastSaveAsLocationChanged();
      }
    }

    Q_PROPERTY(QUrl lastSaveAsLocation READ lastSaveAsLocation WRITE setLastSaveAsLocation NOTIFY lastSaveAsLocationChanged)
    Q_PROPERTY(bool isLastSaveAsLocationImmutable READ isLastSaveAsLocationImmutable CONSTANT)
    /**
      Get Last path used for "save as" action
    */
    static
    QUrl lastSaveAsLocation()
    {
      return self()->mLastSaveAsLocation;
    }

    /**
      Is Last path used for "save as" action Immutable
    */
    static
    bool isLastSaveAsLocationImmutable()
    {
      return self()->isImmutable( QStringLiteral( "lastSaveAsLocation" ) );
    }

    /**
      Set The last used annotation tool type
    */
    static
    void setAnnotationToolType( int v )
    {
      if (v != self()->mAnnotationToolType && !self()->isAnnotationToolTypeImmutable()) {
        self()->mAnnotationToolType = v;
        Q_EMIT self()->annotationToolTypeChanged();
      }
    }

    Q_PROPERTY(int annotationToolType READ annotationToolType WRITE setAnnotationToolType NOTIFY annotationToolTypeChanged)
    Q_PROPERTY(bool isAnnotationToolTypeImmutable READ isAnnotationToolTypeImmutable CONSTANT)
    /**
      Get The last used annotation tool type
    */
    static
    int annotationToolType()
    {
      return self()->mAnnotationToolType;
    }

    /**
      Is The last used annotation tool type Immutable
    */
    static
    bool isAnnotationToolTypeImmutable()
    {
      return self()->isImmutable( QStringLiteral( "annotationToolType" ) );
    }

    /**
      Set Stroke width for freehand annotation tool
    */
    static
    void setFreehandStrokeWidth( uint v )
    {
      if (v < 1)
      {
        qDebug() << "setFreehandStrokeWidth: value " << v << " is less than the minimum value of 1";
        v = 1;
      }
      if (v != self()->mFreehandStrokeWidth && !self()->isFreehandStrokeWidthImmutable()) {
        self()->mFreehandStrokeWidth = v;
        Q_EMIT self()->freehandStrokeWidthChanged();
      }
    }

    Q_PROPERTY(uint freehandStrokeWidth READ freehandStrokeWidth WRITE setFreehandStrokeWidth NOTIFY freehandStrokeWidthChanged)
    Q_PROPERTY(bool isFreehandStrokeWidthImmutable READ isFreehandStrokeWidthImmutable CONSTANT)
    /**
      Get Stroke width for freehand annotation tool
    */
    static
    uint freehandStrokeWidth()
    {
      return self()->mFreehandStrokeWidth;
    }

    /**
      Is Stroke width for freehand annotation tool Immutable
    */
    static
    bool isFreehandStrokeWidthImmutable()
    {
      return self()->isImmutable( QStringLiteral( "freehandStrokeWidth" ) );
    }

    /**
      Set Stroke width for highlighter annotation tool
    */
    static
    void setHighlighterStrokeWidth( uint v )
    {
      if (v < 1)
      {
        qDebug() << "setHighlighterStrokeWidth: value " << v << " is less than the minimum value of 1";
        v = 1;
      }
      if (v != self()->mHighlighterStrokeWidth && !self()->isHighlighterStrokeWidthImmutable()) {
        self()->mHighlighterStrokeWidth = v;
        Q_EMIT self()->highlighterStrokeWidthChanged();
      }
    }

    Q_PROPERTY(uint highlighterStrokeWidth READ highlighterStrokeWidth WRITE setHighlighterStrokeWidth NOTIFY highlighterStrokeWidthChanged)
    Q_PROPERTY(bool isHighlighterStrokeWidthImmutable READ isHighlighterStrokeWidthImmutable CONSTANT)
    /**
      Get Stroke width for highlighter annotation tool
    */
    static
    uint highlighterStrokeWidth()
    {
      return self()->mHighlighterStrokeWidth;
    }

    /**
      Is Stroke width for highlighter annotation tool Immutable
    */
    static
    bool isHighlighterStrokeWidthImmutable()
    {
      return self()->isImmutable( QStringLiteral( "highlighterStrokeWidth" ) );
    }

    /**
      Set Stroke width for line annotation tool
    */
    static
    void setLineStrokeWidth( uint v )
    {
      if (v < 1)
      {
        qDebug() << "setLineStrokeWidth: value " << v << " is less than the minimum value of 1";
        v = 1;
      }
      if (v != self()->mLineStrokeWidth && !self()->isLineStrokeWidthImmutable()) {
        self()->mLineStrokeWidth = v;
        Q_EMIT self()->lineStrokeWidthChanged();
      }
    }

    Q_PROPERTY(uint lineStrokeWidth READ lineStrokeWidth WRITE setLineStrokeWidth NOTIFY lineStrokeWidthChanged)
    Q_PROPERTY(bool isLineStrokeWidthImmutable READ isLineStrokeWidthImmutable CONSTANT)
    /**
      Get Stroke width for line annotation tool
    */
    static
    uint lineStrokeWidth()
    {
      return self()->mLineStrokeWidth;
    }

    /**
      Is Stroke width for line annotation tool Immutable
    */
    static
    bool isLineStrokeWidthImmutable()
    {
      return self()->isImmutable( QStringLiteral( "lineStrokeWidth" ) );
    }

    /**
      Set Stroke width for arrow annotation tool
    */
    static
    void setArrowStrokeWidth( uint v )
    {
      if (v < 1)
      {
        qDebug() << "setArrowStrokeWidth: value " << v << " is less than the minimum value of 1";
        v = 1;
      }
      if (v != self()->mArrowStrokeWidth && !self()->isArrowStrokeWidthImmutable()) {
        self()->mArrowStrokeWidth = v;
        Q_EMIT self()->arrowStrokeWidthChanged();
      }
    }

    Q_PROPERTY(uint arrowStrokeWidth READ arrowStrokeWidth WRITE setArrowStrokeWidth NOTIFY arrowStrokeWidthChanged)
    Q_PROPERTY(bool isArrowStrokeWidthImmutable READ isArrowStrokeWidthImmutable CONSTANT)
    /**
      Get Stroke width for arrow annotation tool
    */
    static
    uint arrowStrokeWidth()
    {
      return self()->mArrowStrokeWidth;
    }

    /**
      Is Stroke width for arrow annotation tool Immutable
    */
    static
    bool isArrowStrokeWidthImmutable()
    {
      return self()->isImmutable( QStringLiteral( "arrowStrokeWidth" ) );
    }

    /**
      Set Stroke width for rectangle annotation tool
    */
    static
    void setRectangleStrokeWidth( uint v )
    {
      if (v != self()->mRectangleStrokeWidth && !self()->isRectangleStrokeWidthImmutable()) {
        self()->mRectangleStrokeWidth = v;
        Q_EMIT self()->rectangleStrokeWidthChanged();
      }
    }

    Q_PROPERTY(uint rectangleStrokeWidth READ rectangleStrokeWidth WRITE setRectangleStrokeWidth NOTIFY rectangleStrokeWidthChanged)
    Q_PROPERTY(bool isRectangleStrokeWidthImmutable READ isRectangleStrokeWidthImmutable CONSTANT)
    /**
      Get Stroke width for rectangle annotation tool
    */
    static
    uint rectangleStrokeWidth()
    {
      return self()->mRectangleStrokeWidth;
    }

    /**
      Is Stroke width for rectangle annotation tool Immutable
    */
    static
    bool isRectangleStrokeWidthImmutable()
    {
      return self()->isImmutable( QStringLiteral( "rectangleStrokeWidth" ) );
    }

    /**
      Set Stroke width for ellipse annotation tool
    */
    static
    void setEllipseStrokeWidth( uint v )
    {
      if (v != self()->mEllipseStrokeWidth && !self()->isEllipseStrokeWidthImmutable()) {
        self()->mEllipseStrokeWidth = v;
        Q_EMIT self()->ellipseStrokeWidthChanged();
      }
    }

    Q_PROPERTY(uint ellipseStrokeWidth READ ellipseStrokeWidth WRITE setEllipseStrokeWidth NOTIFY ellipseStrokeWidthChanged)
    Q_PROPERTY(bool isEllipseStrokeWidthImmutable READ isEllipseStrokeWidthImmutable CONSTANT)
    /**
      Get Stroke width for ellipse annotation tool
    */
    static
    uint ellipseStrokeWidth()
    {
      return self()->mEllipseStrokeWidth;
    }

    /**
      Is Stroke width for ellipse annotation tool Immutable
    */
    static
    bool isEllipseStrokeWidthImmutable()
    {
      return self()->isImmutable( QStringLiteral( "ellipseStrokeWidth" ) );
    }

    /**
      Set Stroke width for freehand annotation tool
    */
    static
    void setFreehandStrokeColor( const QColor & v )
    {
      if (v != self()->mFreehandStrokeColor && !self()->isFreehandStrokeColorImmutable()) {
        self()->mFreehandStrokeColor = v;
        Q_EMIT self()->freehandStrokeColorChanged();
      }
    }

    Q_PROPERTY(QColor freehandStrokeColor READ freehandStrokeColor WRITE setFreehandStrokeColor NOTIFY freehandStrokeColorChanged)
    Q_PROPERTY(bool isFreehandStrokeColorImmutable READ isFreehandStrokeColorImmutable CONSTANT)
    /**
      Get Stroke width for freehand annotation tool
    */
    static
    QColor freehandStrokeColor()
    {
      return self()->mFreehandStrokeColor;
    }

    /**
      Is Stroke width for freehand annotation tool Immutable
    */
    static
    bool isFreehandStrokeColorImmutable()
    {
      return self()->isImmutable( QStringLiteral( "freehandStrokeColor" ) );
    }

    /**
      Set Stroke width for highlighter annotation tool
    */
    static
    void setHighlighterStrokeColor( const QColor & v )
    {
      if (v != self()->mHighlighterStrokeColor && !self()->isHighlighterStrokeColorImmutable()) {
        self()->mHighlighterStrokeColor = v;
        Q_EMIT self()->highlighterStrokeColorChanged();
      }
    }

    Q_PROPERTY(QColor highlighterStrokeColor READ highlighterStrokeColor WRITE setHighlighterStrokeColor NOTIFY highlighterStrokeColorChanged)
    Q_PROPERTY(bool isHighlighterStrokeColorImmutable READ isHighlighterStrokeColorImmutable CONSTANT)
    /**
      Get Stroke width for highlighter annotation tool
    */
    static
    QColor highlighterStrokeColor()
    {
      return self()->mHighlighterStrokeColor;
    }

    /**
      Is Stroke width for highlighter annotation tool Immutable
    */
    static
    bool isHighlighterStrokeColorImmutable()
    {
      return self()->isImmutable( QStringLiteral( "highlighterStrokeColor" ) );
    }

    /**
      Set Stroke width for line annotation tool
    */
    static
    void setLineStrokeColor( const QColor & v )
    {
      if (v != self()->mLineStrokeColor && !self()->isLineStrokeColorImmutable()) {
        self()->mLineStrokeColor = v;
        Q_EMIT self()->lineStrokeColorChanged();
      }
    }

    Q_PROPERTY(QColor lineStrokeColor READ lineStrokeColor WRITE setLineStrokeColor NOTIFY lineStrokeColorChanged)
    Q_PROPERTY(bool isLineStrokeColorImmutable READ isLineStrokeColorImmutable CONSTANT)
    /**
      Get Stroke width for line annotation tool
    */
    static
    QColor lineStrokeColor()
    {
      return self()->mLineStrokeColor;
    }

    /**
      Is Stroke width for line annotation tool Immutable
    */
    static
    bool isLineStrokeColorImmutable()
    {
      return self()->isImmutable( QStringLiteral( "lineStrokeColor" ) );
    }

    /**
      Set Stroke width for arrow annotation tool
    */
    static
    void setArrowStrokeColor( const QColor & v )
    {
      if (v != self()->mArrowStrokeColor && !self()->isArrowStrokeColorImmutable()) {
        self()->mArrowStrokeColor = v;
        Q_EMIT self()->arrowStrokeColorChanged();
      }
    }

    Q_PROPERTY(QColor arrowStrokeColor READ arrowStrokeColor WRITE setArrowStrokeColor NOTIFY arrowStrokeColorChanged)
    Q_PROPERTY(bool isArrowStrokeColorImmutable READ isArrowStrokeColorImmutable CONSTANT)
    /**
      Get Stroke width for arrow annotation tool
    */
    static
    QColor arrowStrokeColor()
    {
      return self()->mArrowStrokeColor;
    }

    /**
      Is Stroke width for arrow annotation tool Immutable
    */
    static
    bool isArrowStrokeColorImmutable()
    {
      return self()->isImmutable( QStringLiteral( "arrowStrokeColor" ) );
    }

    /**
      Set Stroke width for rectangle annotation tool
    */
    static
    void setRectangleStrokeColor( const QColor & v )
    {
      if (v != self()->mRectangleStrokeColor && !self()->isRectangleStrokeColorImmutable()) {
        self()->mRectangleStrokeColor = v;
        Q_EMIT self()->rectangleStrokeColorChanged();
      }
    }

    Q_PROPERTY(QColor rectangleStrokeColor READ rectangleStrokeColor WRITE setRectangleStrokeColor NOTIFY rectangleStrokeColorChanged)
    Q_PROPERTY(bool isRectangleStrokeColorImmutable READ isRectangleStrokeColorImmutable CONSTANT)
    /**
      Get Stroke width for rectangle annotation tool
    */
    static
    QColor rectangleStrokeColor()
    {
      return self()->mRectangleStrokeColor;
    }

    /**
      Is Stroke width for rectangle annotation tool Immutable
    */
    static
    bool isRectangleStrokeColorImmutable()
    {
      return self()->isImmutable( QStringLiteral( "rectangleStrokeColor" ) );
    }

    /**
      Set Stroke width for ellipse annotation tool
    */
    static
    void setEllipseStrokeColor( const QColor & v )
    {
      if (v != self()->mEllipseStrokeColor && !self()->isEllipseStrokeColorImmutable()) {
        self()->mEllipseStrokeColor = v;
        Q_EMIT self()->ellipseStrokeColorChanged();
      }
    }

    Q_PROPERTY(QColor ellipseStrokeColor READ ellipseStrokeColor WRITE setEllipseStrokeColor NOTIFY ellipseStrokeColorChanged)
    Q_PROPERTY(bool isEllipseStrokeColorImmutable READ isEllipseStrokeColorImmutable CONSTANT)
    /**
      Get Stroke width for ellipse annotation tool
    */
    static
    QColor ellipseStrokeColor()
    {
      return self()->mEllipseStrokeColor;
    }

    /**
      Is Stroke width for ellipse annotation tool Immutable
    */
    static
    bool isEllipseStrokeColorImmutable()
    {
      return self()->isImmutable( QStringLiteral( "ellipseStrokeColor" ) );
    }

    /**
      Set Stroke width for rectangle annotation tool
    */
    static
    void setRectangleFillColor( const QColor & v )
    {
      if (v != self()->mRectangleFillColor && !self()->isRectangleFillColorImmutable()) {
        self()->mRectangleFillColor = v;
        Q_EMIT self()->rectangleFillColorChanged();
      }
    }

    Q_PROPERTY(QColor rectangleFillColor READ rectangleFillColor WRITE setRectangleFillColor NOTIFY rectangleFillColorChanged)
    Q_PROPERTY(bool isRectangleFillColorImmutable READ isRectangleFillColorImmutable CONSTANT)
    /**
      Get Stroke width for rectangle annotation tool
    */
    static
    QColor rectangleFillColor()
    {
      return self()->mRectangleFillColor;
    }

    /**
      Is Stroke width for rectangle annotation tool Immutable
    */
    static
    bool isRectangleFillColorImmutable()
    {
      return self()->isImmutable( QStringLiteral( "rectangleFillColor" ) );
    }

    /**
      Set Stroke width for ellipse annotation tool
    */
    static
    void setEllipseFillColor( const QColor & v )
    {
      if (v != self()->mEllipseFillColor && !self()->isEllipseFillColorImmutable()) {
        self()->mEllipseFillColor = v;
        Q_EMIT self()->ellipseFillColorChanged();
      }
    }

    Q_PROPERTY(QColor ellipseFillColor READ ellipseFillColor WRITE setEllipseFillColor NOTIFY ellipseFillColorChanged)
    Q_PROPERTY(bool isEllipseFillColorImmutable READ isEllipseFillColorImmutable CONSTANT)
    /**
      Get Stroke width for ellipse annotation tool
    */
    static
    QColor ellipseFillColor()
    {
      return self()->mEllipseFillColor;
    }

    /**
      Is Stroke width for ellipse annotation tool Immutable
    */
    static
    bool isEllipseFillColorImmutable()
    {
      return self()->isImmutable( QStringLiteral( "ellipseFillColor" ) );
    }

    /**
      Set Stroke width for ellipse annotation tool
    */
    static
    void setNumberFillColor( const QColor & v )
    {
      if (v != self()->mNumberFillColor && !self()->isNumberFillColorImmutable()) {
        self()->mNumberFillColor = v;
        Q_EMIT self()->numberFillColorChanged();
      }
    }

    Q_PROPERTY(QColor numberFillColor READ numberFillColor WRITE setNumberFillColor NOTIFY numberFillColorChanged)
    Q_PROPERTY(bool isNumberFillColorImmutable READ isNumberFillColorImmutable CONSTANT)
    /**
      Get Stroke width for ellipse annotation tool
    */
    static
    QColor numberFillColor()
    {
      return self()->mNumberFillColor;
    }

    /**
      Is Stroke width for ellipse annotation tool Immutable
    */
    static
    bool isNumberFillColorImmutable()
    {
      return self()->isImmutable( QStringLiteral( "numberFillColor" ) );
    }

    /**
      Set Font for annotations
    */
    static
    void setTextFont( const QFont & v )
    {
      if (v != self()->mTextFont && !self()->isTextFontImmutable()) {
        self()->mTextFont = v;
        Q_EMIT self()->textFontChanged();
      }
    }

    Q_PROPERTY(QFont textFont READ textFont WRITE setTextFont NOTIFY textFontChanged)
    Q_PROPERTY(bool isTextFontImmutable READ isTextFontImmutable CONSTANT)
    /**
      Get Font for annotations
    */
    static
    QFont textFont()
    {
      return self()->mTextFont;
    }

    /**
      Is Font for annotations Immutable
    */
    static
    bool isTextFontImmutable()
    {
      return self()->isImmutable( QStringLiteral( "textFont" ) );
    }

    /**
      Set Font for annotations
    */
    static
    void setNumberFont( const QFont & v )
    {
      if (v != self()->mNumberFont && !self()->isNumberFontImmutable()) {
        self()->mNumberFont = v;
        Q_EMIT self()->numberFontChanged();
      }
    }

    Q_PROPERTY(QFont numberFont READ numberFont WRITE setNumberFont NOTIFY numberFontChanged)
    Q_PROPERTY(bool isNumberFontImmutable READ isNumberFontImmutable CONSTANT)
    /**
      Get Font for annotations
    */
    static
    QFont numberFont()
    {
      return self()->mNumberFont;
    }

    /**
      Is Font for annotations Immutable
    */
    static
    bool isNumberFontImmutable()
    {
      return self()->isImmutable( QStringLiteral( "numberFont" ) );
    }

    /**
      Set Font color for annotations
    */
    static
    void setTextFontColor( const QColor & v )
    {
      if (v != self()->mTextFontColor && !self()->isTextFontColorImmutable()) {
        self()->mTextFontColor = v;
        Q_EMIT self()->textFontColorChanged();
      }
    }

    Q_PROPERTY(QColor textFontColor READ textFontColor WRITE setTextFontColor NOTIFY textFontColorChanged)
    Q_PROPERTY(bool isTextFontColorImmutable READ isTextFontColorImmutable CONSTANT)
    /**
      Get Font color for annotations
    */
    static
    QColor textFontColor()
    {
      return self()->mTextFontColor;
    }

    /**
      Is Font color for annotations Immutable
    */
    static
    bool isTextFontColorImmutable()
    {
      return self()->isImmutable( QStringLiteral( "textFontColor" ) );
    }

    /**
      Set Font color for annotations
    */
    static
    void setNumberFontColor( const QColor & v )
    {
      if (v != self()->mNumberFontColor && !self()->isNumberFontColorImmutable()) {
        self()->mNumberFontColor = v;
        Q_EMIT self()->numberFontColorChanged();
      }
    }

    Q_PROPERTY(QColor numberFontColor READ numberFontColor WRITE setNumberFontColor NOTIFY numberFontColorChanged)
    Q_PROPERTY(bool isNumberFontColorImmutable READ isNumberFontColorImmutable CONSTANT)
    /**
      Get Font color for annotations
    */
    static
    QColor numberFontColor()
    {
      return self()->mNumberFontColor;
    }

    /**
      Is Font color for annotations Immutable
    */
    static
    bool isNumberFontColorImmutable()
    {
      return self()->isImmutable( QStringLiteral( "numberFontColor" ) );
    }

    /**
      Set Whether freehand annotation tool has a drop shadow
    */
    static
    void setFreehandShadow( bool v )
    {
      if (v != self()->mFreehandShadow && !self()->isFreehandShadowImmutable()) {
        self()->mFreehandShadow = v;
        Q_EMIT self()->freehandShadowChanged();
      }
    }

    Q_PROPERTY(bool freehandShadow READ freehandShadow WRITE setFreehandShadow NOTIFY freehandShadowChanged)
    Q_PROPERTY(bool isFreehandShadowImmutable READ isFreehandShadowImmutable CONSTANT)
    /**
      Get Whether freehand annotation tool has a drop shadow
    */
    static
    bool freehandShadow()
    {
      return self()->mFreehandShadow;
    }

    /**
      Is Whether freehand annotation tool has a drop shadow Immutable
    */
    static
    bool isFreehandShadowImmutable()
    {
      return self()->isImmutable( QStringLiteral( "freehandShadow" ) );
    }

    /**
      Set Whether line annotation tool has a drop shadow
    */
    static
    void setLineShadow( bool v )
    {
      if (v != self()->mLineShadow && !self()->isLineShadowImmutable()) {
        self()->mLineShadow = v;
        Q_EMIT self()->lineShadowChanged();
      }
    }

    Q_PROPERTY(bool lineShadow READ lineShadow WRITE setLineShadow NOTIFY lineShadowChanged)
    Q_PROPERTY(bool isLineShadowImmutable READ isLineShadowImmutable CONSTANT)
    /**
      Get Whether line annotation tool has a drop shadow
    */
    static
    bool lineShadow()
    {
      return self()->mLineShadow;
    }

    /**
      Is Whether line annotation tool has a drop shadow Immutable
    */
    static
    bool isLineShadowImmutable()
    {
      return self()->isImmutable( QStringLiteral( "lineShadow" ) );
    }

    /**
      Set Whether arrow annotation tool has a drop shadow
    */
    static
    void setArrowShadow( bool v )
    {
      if (v != self()->mArrowShadow && !self()->isArrowShadowImmutable()) {
        self()->mArrowShadow = v;
        Q_EMIT self()->arrowShadowChanged();
      }
    }

    Q_PROPERTY(bool arrowShadow READ arrowShadow WRITE setArrowShadow NOTIFY arrowShadowChanged)
    Q_PROPERTY(bool isArrowShadowImmutable READ isArrowShadowImmutable CONSTANT)
    /**
      Get Whether arrow annotation tool has a drop shadow
    */
    static
    bool arrowShadow()
    {
      return self()->mArrowShadow;
    }

    /**
      Is Whether arrow annotation tool has a drop shadow Immutable
    */
    static
    bool isArrowShadowImmutable()
    {
      return self()->isImmutable( QStringLiteral( "arrowShadow" ) );
    }

    /**
      Set Whether rectangle annotation tool has a drop shadow
    */
    static
    void setRectangleShadow( bool v )
    {
      if (v != self()->mRectangleShadow && !self()->isRectangleShadowImmutable()) {
        self()->mRectangleShadow = v;
        Q_EMIT self()->rectangleShadowChanged();
      }
    }

    Q_PROPERTY(bool rectangleShadow READ rectangleShadow WRITE setRectangleShadow NOTIFY rectangleShadowChanged)
    Q_PROPERTY(bool isRectangleShadowImmutable READ isRectangleShadowImmutable CONSTANT)
    /**
      Get Whether rectangle annotation tool has a drop shadow
    */
    static
    bool rectangleShadow()
    {
      return self()->mRectangleShadow;
    }

    /**
      Is Whether rectangle annotation tool has a drop shadow Immutable
    */
    static
    bool isRectangleShadowImmutable()
    {
      return self()->isImmutable( QStringLiteral( "rectangleShadow" ) );
    }

    /**
      Set Whether ellipse annotation tool has a drop shadow
    */
    static
    void setEllipseShadow( bool v )
    {
      if (v != self()->mEllipseShadow && !self()->isEllipseShadowImmutable()) {
        self()->mEllipseShadow = v;
        Q_EMIT self()->ellipseShadowChanged();
      }
    }

    Q_PROPERTY(bool ellipseShadow READ ellipseShadow WRITE setEllipseShadow NOTIFY ellipseShadowChanged)
    Q_PROPERTY(bool isEllipseShadowImmutable READ isEllipseShadowImmutable CONSTANT)
    /**
      Get Whether ellipse annotation tool has a drop shadow
    */
    static
    bool ellipseShadow()
    {
      return self()->mEllipseShadow;
    }

    /**
      Is Whether ellipse annotation tool has a drop shadow Immutable
    */
    static
    bool isEllipseShadowImmutable()
    {
      return self()->isImmutable( QStringLiteral( "ellipseShadow" ) );
    }

    /**
      Set Whether text annotation tool has a drop shadow
    */
    static
    void setTextShadow( bool v )
    {
      if (v != self()->mTextShadow && !self()->isTextShadowImmutable()) {
        self()->mTextShadow = v;
        Q_EMIT self()->textShadowChanged();
      }
    }

    Q_PROPERTY(bool textShadow READ textShadow WRITE setTextShadow NOTIFY textShadowChanged)
    Q_PROPERTY(bool isTextShadowImmutable READ isTextShadowImmutable CONSTANT)
    /**
      Get Whether text annotation tool has a drop shadow
    */
    static
    bool textShadow()
    {
      return self()->mTextShadow;
    }

    /**
      Is Whether text annotation tool has a drop shadow Immutable
    */
    static
    bool isTextShadowImmutable()
    {
      return self()->isImmutable( QStringLiteral( "textShadow" ) );
    }

    /**
      Set Whether number annotation tool has a drop shadow
    */
    static
    void setNumberShadow( bool v )
    {
      if (v != self()->mNumberShadow && !self()->isNumberShadowImmutable()) {
        self()->mNumberShadow = v;
        Q_EMIT self()->numberShadowChanged();
      }
    }

    Q_PROPERTY(bool numberShadow READ numberShadow WRITE setNumberShadow NOTIFY numberShadowChanged)
    Q_PROPERTY(bool isNumberShadowImmutable READ isNumberShadowImmutable CONSTANT)
    /**
      Get Whether number annotation tool has a drop shadow
    */
    static
    bool numberShadow()
    {
      return self()->mNumberShadow;
    }

    /**
      Is Whether number annotation tool has a drop shadow Immutable
    */
    static
    bool isNumberShadowImmutable()
    {
      return self()->isImmutable( QStringLiteral( "numberShadow" ) );
    }


    enum {
      signalLaunchActionChanged = 1,
      signalPrintKeyActionRunningChanged = 2,
      signalAutoSaveImageChanged = 3,
      signalClipboardGroupChanged = 4,
      signalUseLightMaskColorChanged = 5,
      signalShowMagnifierChanged = 6,
      signalUseReleaseToCaptureChanged = 7,
      signalShowCaptureInstructionsChanged = 8,
      signalRememberLastRectangularRegionChanged = 9,
      signalCropRegionChanged = 10,
      signalCaptureOnClickChanged = 11,
      signalIncludePointerChanged = 12,
      signalIncludeDecorationsChanged = 13,
      signalTransientOnlyChanged = 14,
      signalQuitAfterSaveCopyExportChanged = 15,
      signalCaptureDelayChanged = 16,
      signalCaptureModeChanged = 17,
      signalDefaultSaveLocationChanged = 18,
      signalDefaultVideoSaveLocationChanged = 19,
      signalCompressionQualityChanged = 20,
      signalDefaultSaveImageFormatChanged = 21,
      signalDefaultSaveVideoFormatChanged = 22,
      signalSaveFilenameFormatChanged = 23,
      signalSaveVideoFormatChanged = 24,
      signalLastSaveLocationChanged = 25,
      signalLastSaveAsLocationChanged = 26,
      signalAnnotationToolTypeChanged = 27,
      signalFreehandStrokeWidthChanged = 28,
      signalHighlighterStrokeWidthChanged = 29,
      signalLineStrokeWidthChanged = 30,
      signalArrowStrokeWidthChanged = 31,
      signalRectangleStrokeWidthChanged = 32,
      signalEllipseStrokeWidthChanged = 33,
      signalFreehandStrokeColorChanged = 34,
      signalHighlighterStrokeColorChanged = 35,
      signalLineStrokeColorChanged = 36,
      signalArrowStrokeColorChanged = 37,
      signalRectangleStrokeColorChanged = 38,
      signalEllipseStrokeColorChanged = 39,
      signalRectangleFillColorChanged = 40,
      signalEllipseFillColorChanged = 41,
      signalNumberFillColorChanged = 42,
      signalTextFontChanged = 43,
      signalNumberFontChanged = 44,
      signalTextFontColorChanged = 45,
      signalNumberFontColorChanged = 46,
      signalFreehandShadowChanged = 47,
      signalLineShadowChanged = 48,
      signalArrowShadowChanged = 49,
      signalRectangleShadowChanged = 50,
      signalEllipseShadowChanged = 51,
      signalTextShadowChanged = 52,
      signalNumberShadowChanged = 53
    };

  Q_SIGNALS:
    void launchActionChanged();

    void printKeyActionRunningChanged();

    void autoSaveImageChanged();

    void clipboardGroupChanged();

    void useLightMaskColorChanged();

    void showMagnifierChanged();

    void useReleaseToCaptureChanged();

    void showCaptureInstructionsChanged();

    void rememberLastRectangularRegionChanged();

    void cropRegionChanged();

    void captureOnClickChanged();

    void includePointerChanged();

    void includeDecorationsChanged();

    void transientOnlyChanged();

    void quitAfterSaveCopyExportChanged();

    void captureDelayChanged();

    void captureModeChanged();

    void defaultSaveLocationChanged();

    void defaultVideoSaveLocationChanged();

    void compressionQualityChanged();

    void defaultSaveImageFormatChanged();

    void defaultSaveVideoFormatChanged();

    void saveFilenameFormatChanged();

    void saveVideoFormatChanged();

    void lastSaveLocationChanged();

    void lastSaveAsLocationChanged();

    void annotationToolTypeChanged();

    void freehandStrokeWidthChanged();

    void highlighterStrokeWidthChanged();

    void lineStrokeWidthChanged();

    void arrowStrokeWidthChanged();

    void rectangleStrokeWidthChanged();

    void ellipseStrokeWidthChanged();

    void freehandStrokeColorChanged();

    void highlighterStrokeColorChanged();

    void lineStrokeColorChanged();

    void arrowStrokeColorChanged();

    void rectangleStrokeColorChanged();

    void ellipseStrokeColorChanged();

    void rectangleFillColorChanged();

    void ellipseFillColorChanged();

    void numberFillColorChanged();

    void textFontChanged();

    void numberFontChanged();

    void textFontColorChanged();

    void numberFontColorChanged();

    void freehandShadowChanged();

    void lineShadowChanged();

    void arrowShadowChanged();

    void rectangleShadowChanged();

    void ellipseShadowChanged();

    void textShadowChanged();

    void numberShadowChanged();

  private:
    void itemChanged(quint64 signalFlag);

  protected:
    Settings();
    friend class SettingsHelper;


    // General
    int mLaunchAction;
    int mPrintKeyActionRunning;
    bool mAutoSaveImage;
    int mClipboardGroup;
    bool mUseLightMaskColor;
    bool mShowMagnifier;
    bool mUseReleaseToCapture;
    bool mShowCaptureInstructions;
    int mRememberLastRectangularRegion;

    // GuiConfig
    QRect mCropRegion;
    bool mCaptureOnClick;
    bool mIncludePointer;
    bool mIncludeDecorations;
    bool mTransientOnly;
    bool mQuitAfterSaveCopyExport;
    double mCaptureDelay;
    int mCaptureMode;

    // Save
    QUrl mDefaultSaveLocation;
    QUrl mDefaultVideoSaveLocation;
    uint mCompressionQuality;
    QString mDefaultSaveImageFormat;
    QString mDefaultSaveVideoFormat;
    QString mSaveFilenameFormat;
    QString mSaveVideoFormat;
    QUrl mLastSaveLocation;
    QUrl mLastSaveAsLocation;

    // Annotations
    int mAnnotationToolType;
    uint mFreehandStrokeWidth;
    uint mHighlighterStrokeWidth;
    uint mLineStrokeWidth;
    uint mArrowStrokeWidth;
    uint mRectangleStrokeWidth;
    uint mEllipseStrokeWidth;
    QColor mFreehandStrokeColor;
    QColor mHighlighterStrokeColor;
    QColor mLineStrokeColor;
    QColor mArrowStrokeColor;
    QColor mRectangleStrokeColor;
    QColor mEllipseStrokeColor;
    QColor mRectangleFillColor;
    QColor mEllipseFillColor;
    QColor mNumberFillColor;
    QFont mTextFont;
    QFont mNumberFont;
    QColor mTextFontColor;
    QColor mNumberFontColor;
    bool mFreehandShadow;
    bool mLineShadow;
    bool mArrowShadow;
    bool mRectangleShadow;
    bool mEllipseShadow;
    bool mTextShadow;
    bool mNumberShadow;

  private:
};

#endif

